<template>
  <div :class="sidebarClasses" :data-background-color="backgroundColor" :data-active-color="activeColor">
    <div class="logo">
      <a class="simple-text logo-mini" href="#">
        <div class="logo-img">
          <img :src="logo" alt="" class="">
        </div>
      </a>
      <!-- <a class="simple-text logo-normal" href="">
        {{ title }}
      </a> -->
      <h2 class=" simple-text logo-normal ml-3 m-0 ">
        <!-- {{ title }} -->
        <img src="static/img/background/declaranet_txt.png" alt="" class="dnet-txt">
      </h2>
    </div>
    <div class="sidebar-wrapper" ref="sidebarScrollArea">
      <ul :class="navClasses">
        <slot name="links">
          <sidebar-item v-for="(link, index) in sidebarLinks" :key="link.name + index" :link="link" class="ml-3 mt-3 mr-3 mw">
            <sidebar-item v-for="(subLink, index) in link.children" :key="subLink.name + index" :link="subLink" class="col-12 d-inline-block-flex p-2">
            </sidebar-item>
          </sidebar-item>
        </slot>
      </ul>
    </div>
  </div>
</template>
<script>
  export default {
    props: {
      title: {
        type: String,
        default: 'DeclaraNET 2019'
      },
      type: {
        type: String,
        default: 'sidebar',
        validator: (value) => {
          let acceptedValues = ['sidebar', 'navbar']
          return acceptedValues.indexOf(value) !== -1
        }
      },
      backgroundColor: {
        type: String,
        default: 'white',
        validator: (value) => {
          let acceptedValues = ['white', 'brown', 'black']
          return acceptedValues.indexOf(value) !== -1
        }
      },
      activeColor: {
        type: String,
        default: 'info',
        validator: (value) => {
          let acceptedValues = ['primary', 'info', 'success', 'warning', 'danger']
          return acceptedValues.indexOf(value) !== -1
        }
      },
      logo: {
        type: String,
        default: 'static/img/background/icon_logo.png'
      },
      sidebarLinks: {
        type: Array,
        default: () => []
      }
    },
    data() {
      return {
        visible: null,
        isClosed: true,
      }
    },
    watch: {
      visible: function () {
        //console.log('--->', this.visible);
      },
      $sidebar: {
        handler: function (val, oldval) {
          //this.change = true;
          //console.log(this.$sidebar);
        },
        deep: true
      },
    },
    computed: {
      sidebarClasses() {
        if (this.type === 'sidebar') {
          return 'sidebar'
        } else {
          return 'collapse navbar-collapse off-canvas-sidebar'
        }
      },
      navClasses() {
        if (this.type === 'sidebar') {
          return 'nav'
        } else {
          return 'nav navbar-nav'
        }
      }
    },
    methods: {
      async initScrollBarAsync() {
        await import('perfect-scrollbar/dist/css/perfect-scrollbar.css')
        const PerfectScroll = await import('perfect-scrollbar')
        PerfectScroll.initialize(this.$refs.sidebarScrollArea)
      },
      cerrarSesion() {
        localStorage.clear();
        this.$router.push('/');
      }
    },
    created() {},
    mounted() {
      this.initScrollBarAsync();
      this.visible = document.querySelector('.sidebar-normal'); //.querySelector('.sidebar-normal')
      //this.visible.style.opacity = 0;
      //console.log(this.$sidebar);

      let grupo = 0
      let rol = 0
      let stats = 0

      if (localStorage.getItem('app-token-declaranet')) {
        grupo = this.getKey('grupo');
        rol = this.getKey('role');
        stats = this.getKey('status_dec');
        // console.log(rol)
      }

      let declaracion
      let menu;
      let declaraciones;

      if (stats == 1) {

        if (grupo == 3) { ///si es el g
          declaracion = [{
              name: 'Guía de llenado',
              path: 'https:' + this.$rootUrl + '/Guia.pdf',
              icon: 'fas fa-file-pdf fa-xs',
              target: '_blank'
            }, {
              name: 'Información Personal',
              path: '/forms/infpersonal',
              icon: 'fas fa-user-cog fa-xs'
            },
            {
              name: 'Ingresos',
              path: '/forms/ingresos',
              icon: 'fas fa-dollar-sign fa-xs'
            }
          ];
        } else {
          declaracion = [{
              name: 'Guía de llenado',
              path: 'https:' + this.$rootUrl + '/Guia.pdf',
              icon: 'fas fa-file-pdf fa-xs',
              target: '_blank'
            },
            {
              name: 'Información Personal',
              path: '/forms/infpersonal',
              icon: 'fas fa-user-cog fa-xs'
            },
            {
              name: 'Intereses',
              path: '/forms/intereses',
              icon: 'fas fa-file-invoice-dollar fa-xs'
            },
            {
              name: 'Ingresos',
              path: '/forms/ingresos',
              icon: 'fas fa-dollar-sign fa-xs'
            },
            {
              name: 'Activos',
              path: '/forms/activos',
              icon: 'fas fa-hand-holding-usd fa-xs'
            },
            {
              name: 'Pasivos',
              path: '/forms/pasivos',
              icon: 'fas fa-money-bill fa-xs'
            },
            {
              name: 'Declaración Fiscal',
              path: '/forms/fiscal',
              icon: 'fas fa-balance-scale fa-xs'
            },
            {
              name: 'Resumen',
              path: '/forms/resumen',
              icon: 'fas fa-file-invoice fa-xs'
            },
            /*{
              name: 'Acuse',
              path: '/forms/enviada',
              icon: 'fas fa-file-invoice fa-xs'
            }*/

          ];
        }

        declaraciones = [{
          name: 'Declaración 2019',
          path: '/forms/infpersonal',
          icon: 'fas fa-angle-right fa-xs'
        }];
      } else {
        //si ya la envio
        declaracion = [{
          name: 'Enviada',
          path: '/forms/enviada',
          icon: 'fas fa-user-cog fa-xs'
        }];
        declaraciones = [{
          name: 'Declaración 2019',
          path: '/forms/enviada',
          icon: 'fas fa-angle-right fa-xs'
        }]

      }
      if (rol != 0) { //si es administrador, mostrar menú completo
        if (rol == 4) { //si es de rh solo puede cargar plantilla y ver reporte de
          menu = [{
            name: 'Padrón',
            icon: 'ti-agenda',
            collapsed: true,
            children: [{
                name: 'Altas de personal',
                path: '#',
                icon: 'fas fa-user-plus fa-xs'

              },
              {
                name: 'Movimientos',
                path: '/admin/movimientos',
                icon: 'fas fa-user-edit fa-xs'
              },
              {
                name: 'Plantilla',
                path: '/admin/plantilla',
                icon: 'fas fa-file-excel fa-xs'
              }
            ]
          }, {
            name: 'Reportes',
            icon: 'ti-printer',
            children: [{
                name: 'Declaraciones',
                path: '/reportes/declaraciones',
                icon: 'fas fa-clipboard-list fa-xs'
              },
              {
                name: 'Movimientos',
                path: '#',
                icon: 'fas fa-arrows-alt fa-xs'
              },
              {
                name: 'Cumplimiento',
                path: '/reportes/cumplimiento',
                icon: 'fas fa-tasks fa-xs'
              }
            ]
          }]
        } else {
          menu = [{
              name: 'Declaraciones',
              icon: 'ti-clipboard',
              children: [{
                  name: 'Declaraciones',
                  path: '/reportes/declaraciones',
                  icon: 'fas fa-clipboard-list fa-xs'
                },
                {
                  name: 'Verificación',
                  path: '#',
                  icon: 'fas fa-check-double fa-xs'
                }
              ]
            },
            {
              name: 'Padrón',
              icon: 'ti-agenda',
              collapsed: true,
              children: [{
                  name: 'Altas de personal',
                  path: '#',
                  icon: 'fas fa-user-plus fa-xs'

                },
                {
                  name: 'Movimientos',
                  path: '/admin/movimientos',
                  icon: 'fas fa-user-edit fa-xs'
                },
                {
                  name: 'Plantilla',
                  path: '/admin/plantilla',
                  icon: 'fas fa-file-excel fa-xs'
                }
              ]
            },
            {
              name: 'Procedimientos',
              icon: 'ti-write',
              collapsed: true,
              children: [{
                  name: 'Casos omisos',
                  path: '#',
                  icon: 'fas fa-eye-slash fa-xs'

                },
                {
                  name: 'Procedimientos',
                  path: '#',
                  icon: 'fas fa-tasks fa-xs'
                }
              ]
            }, {
              name: 'Configuración',
              icon: 'ti-settings',
              collapsed: true,
              children: [{
                name: 'Usuarios',
                path: '/admin/usuarios',
                icon: 'fas fa-users-cog fa-xs'
              }, {
                name: 'Permisos',
                path: '/admin/permisos',
                icon: 'fas fa-key fa-xs'
              }]
            }, {
              name: 'Reportes',
              icon: 'ti-printer',
              children: [{
                  name: 'Declaraciones',
                  path: '/reportes/declaraciones',
                  icon: 'fas fa-clipboard-list fa-xs'
                },
                {
                  name: 'Movimientos',
                  path: '#',
                  icon: 'fas fa-arrows-alt fa-xs'
                },
                {
                  name: 'Cumplimiento',
                  path: '/reportes/cumplimiento',
                  icon: 'fas fa-tasks fa-xs'
                }
              ]
            }
          ]
        }

      } else {
        menu = [{
            name: 'Mis declaraciones',
            icon: 'ti-layout-list-thumb',
            children: declaraciones
          },
          {
            name: 'Declaraciones',
            icon: 'ti-clipboard',
            children: declaracion
          }
        ];

      }
      this.$sidebar.sidebarLinks = menu;
    },
    updated() {
      //console.log(this.$sidebar);
    },
    beforeDestroy() {
      if (this.$sidebar.showSidebar) {
        this.$sidebar.showSidebar = false
      }
    }
  }

</script>
<style>
  @media (min-width: 992px) {

    .navbar-search-form-mobile,
    .nav-mobile-menu {
      display: none !important;
    }
  }


  .logo h2 {
    font-size: 15px !important;
  }

  .sidebar .logo,
  .off-canvas-sidebar .logo {

    padding: 15px 0px !important;
  }

  .sidebar .logo .logo-img,
  .off-canvas-sidebar .logo .logo-img {
    width: 50px !important;
    position: relative !important;
    /* margin-bottom: 8px; */
    top: -5px !important;
  }

  .sidebar .logo a.logo-mini,
  .off-canvas-sidebar .logo a.logo-mini {
    width: 50px !important;
    margin-left: 15px !important;
  }


  .dnet-txt {
    height: 40px !important;
  }

  .sidebar .logo .logo-img img,
  .off-canvas-sidebar .logo .logo-img img {
    max-width: 50px !important;
    margin-bottom: 2px !important;
  }

  .mw {
    min-width: 200px !important;
  }

  /* .nav>li>a {
    position: initial !important;
  } */

</style>
